'
' Effority.Net ( http://www.effority.net )
' Benjamin Hermann, Oliver Dembniak
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports DotNetNuke.Data

Namespace effority.Ealo.Data

    Public Class Controller
        Inherits EaloBase

        Private Shared _FallbackLocale As String

        Private Shared ReadOnly Property FallbackLocale() As String

            Get

                _FallbackLocale = DotNetNuke.Entities.Portals.PortalController.GetCurrentPortalSettings.DefaultLanguage

                Return _FallbackLocale

            End Get

        End Property

        Public Shared Function GetStringById(ByVal Id As Int32) As StringInfo

            ' der Fallback Wert durch einen eigenen DB Zugriff geholt
            ' ist einfacher so
            ' wenn man alles in einer SP erledigt, wird diese bermig komplex

            Dim item As effority.Ealo.StringInfo = effority.Ealo.Utils.MakeStringInfo(DataProvider.Instance.ExecuteReader(SP_Prafix & "GetStringById", Id))

            If Not item Is Nothing Then

                Dim fallbackItem As effority.Ealo.StringInfo = effority.Ealo.Data.Controller.GetStringByQualifierAndStringNameAndLocale(item.Qualifier, item.StringName, FallbackLocale)

                If Not fallbackItem Is Nothing Then
                    item.FallBack = fallbackItem.StringText
                End If
               
            End If
            
            Return item

        End Function

        Public Shared Function GetStringsByQualifierAndLocale(ByVal Qualifier As String, ByVal Locale As String) As Generic.Dictionary(Of String, StringInfo)
            Return effority.Ealo.Utils.MakeStringDic(DataProvider.Instance.ExecuteReader(SP_Prafix & "GetStringsByQualifierAndLocale", Qualifier, Locale, FallbackLocale))
        End Function

        Public Shared Function GetStringByQualifierAndStringNameAndLocale(ByVal Qualifier As String, ByVal StringName As String, ByVal Locale As String) As StringInfo
            Return effority.Ealo.Utils.MakeStringInfo(DataProvider.Instance.ExecuteReader(SP_Prafix & "GetStringByQualifierAndStringNameAndLocale", Qualifier, StringName, Locale, FallbackLocale))
        End Function

        ' dass soll wirklich ein function sein
        Public Shared Function UpdateStringByQualiferAndStringNameAndLocale(ByVal Qualifier As String, ByVal StringName As String, ByVal StringText As String, ByVal Locale As String) As Int32
            Return Convert.ToInt32(DataProvider.Instance.ExecuteScalar(SP_Prafix & "UpdateStringByQualifierAndStringNameAndLocale", Qualifier, StringName, StringText, Locale))
        End Function

        Public Shared Function UpdateStringById(ByVal Id As Int32, ByVal StringText As String) As StringInfo
            Return effority.Ealo.Utils.MakeStringInfo(DataProvider.Instance.ExecuteReader(SP_Prafix & "UpdateStringById", Id, StringText))
        End Function

        Public Shared Sub DeleteById(ByVal Id As Int32)
            DataProvider.Instance.ExecuteNonQuery(SP_Prafix & "DeleteById", Id)
        End Sub

        Public Shared Sub DeleteByQualifier(ByVal Qualifier As String)
            DataProvider.Instance.ExecuteNonQuery(SP_Prafix & "DeleteByQualifier", Qualifier)
        End Sub

        Public Shared Sub DeleteByQualifierAndStringName(ByVal Qualifier As String, ByVal StringName As String)
            DataProvider.Instance.ExecuteNonQuery(SP_Prafix & "DeleteByQualifierAndStringName", Qualifier, StringName)
        End Sub

        Public Shared Sub DeleteByQualifierAndStringNameAndLocale(ByVal Qualifier As String, ByVal StringName As String, ByVal Locale As String)
            DataProvider.Instance.ExecuteNonQuery(SP_Prafix & "DeleteByQualifierAndStringNameAndLocale", Qualifier, StringName, Locale)
        End Sub

        Public Shared Sub DeleteByLocale(ByVal Locale As String)
            DataProvider.Instance.ExecuteNonQuery(SP_Prafix & "DeleteByLocale", Locale)
        End Sub

    End Class

End Namespace