'
' Effority.Net ( http://www.effority.net )
' Benjamin Hermann, Oliver Dembniak
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Namespace effority.Ealo

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Holds the Result of a Ealo Data Access
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    '''		[odem]	    07/2007	created
    ''' </history>
    ''' -----------------------------------------------------------------------------
    ''' 
    Public Class StringInfo

        Private _Id As Int32
        Private _Qualifier As String
        Private _StringName As String
        Private _StringText As String
        Private _Locale As String
        Private _FallBack As String

        Private _StringTextIsNull As Boolean
        Private _FallbackIsNull As Boolean

        Public Sub New()

        End Sub

        Public Sub New(ByVal Qualifier As String, ByVal StringName As String, ByVal StringText As String, ByVal Locale As String)

            Me.Qualifier = Qualifier
            Me.StringName = StringName
            Me.StringText = StringText
            Me.Locale = Locale

        End Sub

        Public Sub New(ByVal Id As Int32, ByVal Qualifier As String, ByVal StringName As String, ByVal StringText As String, ByVal Locale As String)

            Me.Id = Id
            Me.Qualifier = Qualifier
            Me.StringName = StringName
            Me.StringText = StringText
            Me.Locale = Locale

        End Sub

        Public Property Id() As Int32
            Get
                Return _Id
            End Get
            Set(ByVal Value As Int32)
                _Id = Value
            End Set
        End Property

        Public Property Qualifier() As String
            Get
                Return _Qualifier
            End Get
            Set(ByVal Value As String)
                _Qualifier = Value
            End Set
        End Property

        Public Property StringName() As String
            Get
                Return _StringName
            End Get
            Set(ByVal Value As String)
                _StringName = Value
            End Set
        End Property

        Public Property StringText() As String
            Get
                Return _StringText
            End Get
            Set(ByVal Value As String)
                _StringText = Value
            End Set
        End Property

        Public Property Locale() As String
            Get
                Return _Locale
            End Get
            Set(ByVal Value As String)
                _Locale = Value
            End Set
        End Property

        Public Property FallBack() As String
            Get
                Return _FallBack
            End Get
            Set(ByVal Value As String)
                _FallBack = Value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Returns StringText, if StringText is nothng it returns Fallback
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        '''		[odem]	    07/2007	created
        ''' </history>
        ''' -----------------------------------------------------------------------------
        '''
        Public ReadOnly Property StringTextOrFallBack() As String
            Get
                If String.IsNullOrEmpty(_StringText) Then
                    Return _FallBack
                Else
                    Return _StringText
                End If
            End Get
        End Property



        ' das muss so sein ( Set Variante )
        ' erhht die Flexibilitt, falls der Fallback Wert nicht der Wert einer anderen Sprache sein soll 
        Public Property StringTextIsNull() As Boolean
            Get
                Return _StringTextIsNull
            End Get
            Set(ByVal value As Boolean)
                _StringTextIsNull = value
            End Set
        End Property

        Public Property FallbackIsNull() As Boolean
            Get
                Return _FallbackIsNull
            End Get
            Set(ByVal value As Boolean)
                _FallbackIsNull = value
            End Set
        End Property


    End Class

End Namespace
